#!/bin/bash
# Packager : Jean-Philippe Guillemin <jp.guillemin@free.fr>
# sources location : http://squentin.free.fr/gmusicbrowser/download.html


soft='gmusicbrowser'
softversion='1.1.9'
packageversion='72.1'

arch='i486'
cpu='i686'

buildir=$(pwd)
srcpkg="$buildir/$soft-$softversion.tar.gz"
src="$buildir/$soft-$softversion"

package="$soft-$softversion-$arch-$packageversion"

PKG="/tmp/$package"


cd $buildir
rm -rf $src
tar -xvf $srcpkg
rm -f $PKG.tgz
rm -rf $PKG
mkdir -p $PKG
chown -R root:root .

(
cd $src
make install \
DESTDIR=$PKG \
mandir=/usr/man \
iconsdir=$PKG/usr/share/icons/hicolor/32x32/apps \
liconsdir=$PKG/usr/share/icons/hicolor/48x48/apps \
miconsdir=$PKG/usr/share/icons/hicolor/16x16/apps

mkdir -p $PKG/usr/doc/$soft-$softversion
cp -a INSTALL NEWS COPYING AUTHORS README INSTALL layout_doc.html $PKG/usr/doc/$soft-$softversion
rm -rf $PKG/usr/share/doc
)


# Striptease
( cd $PKG
  find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
  find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
  for mandir in $(find . -name man -type d) ; do
  if [ -d $mandir ]; then
    ( cd $mandir
      find . -type f -name "*.?" -exec gzip -9 {} \;
    )
  fi
  done
)

# Install dir
mkdir -p $PKG/install
chmod -R 755 $PKG/install
cat << "EODESC" > $PKG/install/slack-desc
gmusicbrowser: gmusicbrowser - multimedia jukebox
gmusicbrowser:
gmusicbrowser: Gmusicbrowser is an open-source jukebox for large collections 
gmusicbrowser: of mp3/ogg/flac/mpc files, written in perl.
gmusicbrowser:
gmusicbrowser:
gmusicbrowser:
gmusicbrowser:
gmusicbrowser: 
gmusicbrowser:
gmusicbrowser:
EODESC

# Icons
rm -rf $PKG/usr/share/gmusicbrowser/pix
cp -rf $buildir/pix $PKG/usr/share/gmusicbrowser

# Desktop file
mkdir -p $PKG/usr/share/applications
rm -f $PKG/usr/share/applications/*
cat << "EOF" > $PKG/usr/share/applications/gmb.desktop
[Desktop Entry]
Encoding=UTF-8
Type=Application
Name=Gmusicbrowser
GenericName=Jukebox
Comment=Jukebox for large collections of mp3/ogg/flac
Comment[fr]=Jukebox pour de grandes collections de mp3/ogg/flac
Icon=gmusicbrowser
TryExec=gmusicbrowser
Exec=gmusicbrowser
Terminal=false
Categories=Application;AudioVideo;GTK;Tuner;
StartupNotify=true
EOF


mkdir -p $PKG/usr/src/$soft-$softversion
( cd $buildir
cp -a build-$soft.sh $PKG/usr/src/$soft-$softversion/
)

cd $PKG
makepkg -l y -c y $PKG.txz


# cleanup
rm -rf $PKG
rm -rf $src

